namespace eval n3dnode {

}

proc n3dnode::read { w obj } {
#read values in from obj and create the representing widgets

frame $w.f0 -relief sunken -borderwidth 1 
pack  $w.f0 -side top -expand 1
label $w.f0.a -text "Type: n3dnode" -width 800 -anchor w
pack $w.f0.a -side left -fill x -expand 1

frame $w.f1 -relief sunken -borderwidth 1 
pack  $w.f1 -side top -expand 1
label $w.f1.b -text "Name: "
entry $w.f1.b1 -width 800
$w.f1.b1 insert 0 [$obj.getname]
pack $w.f1.b $w.f1.b1 -side left -fill x -expand 1

frame $w.f2 -relief sunken -borderwidth 1
pack  $w.f2 -side top -expand 1
label $w.f2.c -text "Refs: "
label $w.f2.d -text [$obj.getrefcount] -width 800 -anchor w
pack $w.f2.c $w.f2.d -side left -fill x -expand 1

frame $w.f3 -relief sunken -borderwidth 1
pack  $w.f3 -side top -expand 1
label $w.f3.b -text "Active: "
entry $w.f3.b1 -width 800
$w.f3.b1 insert 0 [$obj.getactive]
pack $w.f3.b $w.f3.b1 -side left -fill x -expand 1 

frame $w.f4 -relief sunken -borderwidth 1
pack  $w.f4 -side top -expand 1
label $w.f4.b -text "MinLOD: "
entry $w.f4.b1 -width 800
$w.f4.b1 insert 0 [$obj.getminlod]
pack $w.f4.b $w.f4.b1 -side left -fill x -expand 1

frame $w.f5 -relief sunken -borderwidth 1
pack  $w.f5 -side top -expand 1
label $w.f5.b -text "Sprite: "
entry $w.f5.b1 -width 800
$w.f5.b1 insert 0 [$obj.getsprite]
pack $w.f5.b $w.f5.b1 -side left -fill x -expand 1

frame $w.f6 -relief sunken -borderwidth 1
pack  $w.f6 -side top -expand 1
label $w.f6.b -text "Billboard: "
entry $w.f6.b1 -width 800
$w.f6.b1 insert 0 [$obj.getbillboard]
pack $w.f6.b $w.f6.b1 -side left -fill x -expand 1

frame $w.f7 -relief sunken -borderwidth 1
pack  $w.f7 -side top -expand 1
label $w.f7.b -text "Lockviewer: "
entry $w.f7.b1 -width 800
$w.f7.b1 insert 0 [$obj.getlockviewer]
pack $w.f7.b $w.f7.b1 -side left -fill x -expand 1

frame $w.f8 -relief sunken -borderwidth 1
pack  $w.f8 -side top -expand 1
label $w.f8.b -text "Trans.: "
entry $w.f8.b1 -width 800
$w.f8.b1 insert 0 [$obj.gett]
pack $w.f8.b $w.f8.b1 -side left -fill x -expand 1

frame $w.f9 -relief sunken -borderwidth 1
pack  $w.f9 -side top -expand 1
label $w.f9.b -text "Rot.: "
entry $w.f9.b1 -width 800
$w.f9.b1 insert 0 [$obj.getr]
pack $w.f9.b $w.f9.b1 -side left -fill x -expand 1

frame $w.f10 -relief sunken -borderwidth 1
pack  $w.f10 -side top -expand 1
label $w.f10.b -text "Scale: "
entry $w.f10.b1 -width 800
$w.f10.b1 insert 0 [$obj.gets]
pack $w.f10.b $w.f10.b1 -side left -fill x -expand 1

frame $w.f11 -relief sunken -borderwidth 1
pack  $w.f11 -side top -expand 1
button $w.f11.x -text "Update" -command "n3dnode::update $w $obj" -width 800
pack $w.f11.x -side left -fill x -expand 1

}


proc n3dnode::write { obj filename } {
;#for future use on saving a node structure starting at obj to file filename
}

proc n3dnode::new { w obj } {
;#for future use on creation of a new node 
}

proc n3dnode::update { w node } {

set nname "[$w.f1.b1 get]"

# set the active flag
$node.setactive "[$w.f3.b1 get]"
# set LOD value
$node.setminlod "[$w.f4.b1 get]"
# set sprite flag
$node.setsprite "[$w.f5.b1 get]"
# set billboard flag
$node.setbillboard "[$w.f6.b1 get]"
#set lockviewer flag
$node.setlockviewer "[$w.f7.b1 get]"
#set translation 3f
$node.txyz [lindex [$w.f8.b1 get] 0] [lindex [$w.f8.b1 get] 1] [lindex [$w.f8.b1 get] 2]
#set rotation 3f
$node.rxyz [lindex [$w.f9.b1 get] 0] [lindex [$w.f9.b1 get] 1] [lindex [$w.f9.b1 get] 2]
#set scale 3f
$node.sxyz [lindex [$w.f10.b1 get] 0] [lindex [$w.f10.b1 get] 1] [lindex [$w.f10.b1 get] 2]
# Set the name of the node put it last -> could have changed !
$node.setname "$nname"


# redraw information
#delete old items
set o [pack slaves $w]
foreach old $o {
	destroy $old
}
n3dnode::read "$w" "[file dirname $node]/$nname"

}